<?php
/** Вырезать фрагмент с изображения
 *
 * @param resource $image
 * @param integer $x0
 * @param integer $y0
 * @return resource
 */
function imagecut($image, $x0, $y0){
	$newimage=imagecreatetruecolor(imagesx($image)-$x0, imagesy($image)-$y0);
	imagecopy($newimage, $image, 0, 0, $x0, $y0, imagesx($image), imagesy($image));

	return $newimage;
}

/** Создать картинку с надписью
 *
 * @param string $str
 * @return resource
 */
function image_string($str){
	$image=imagecreate(128, 20);
	$new_color_white=imagecolorallocate($image, 255, 255, 255);
	$new_color_black=imagecolorallocate($image, 0, 0, 0);
	imagefilledrectangle($image, 0, 0, imagesx($image), imagesy($image), $new_color_white);

	imagettftext($image, 12, 0, 0, 15, $new_color_black, 'data/ARIAL.TTF', $str);
	return $image;
}

/** Объеденить два изображения
 *
 * @param resource $image
 * @param resource $second_image
 * @return resource
 */
function imagemerge($image, $second_image){
	$newimage=imagecreatetruecolor(imagesx($image), imagesy($image)+imagesy($second_image));
	$new_color_white=imagecolorallocate($newimage, 255, 255, 255);
	$new_color_black=imagecolorallocate($newimage, 0, 0, 0);
	$new_color_gray=imagecolorallocate($newimage, 105, 125, 125);
	imagefilledrectangle($newimage, 0, 0, imagesx($image), imagesy($image)+imagesy($second_image), $new_color_white);


	imagecopy($newimage, $image, 0, 0, 0, 0, imagesx($image), imagesy($image));

	imagefilledrectangle($newimage, 0, imagesy($image), imagesx($image), imagesy($image)+imagesy($second_image), $new_color_gray);
	imagecopy($newimage, $second_image, 0, imagesy($image), 0, 0, imagesx($second_image), imagesy($second_image));
	return $newimage;
}

/** Вывести изображение в браузер как картинку
 *
 * @param resource $image
 */
function imagepngout($image){
	if(!headers_sent()){
		header('Content-Type: image/png');
		imagepng($image);
		die();
	}else{
		die('Error to out image. Headers already sent.');
	}
}

/** Функция генерации капчи
 *
 * @param string $code код который будет написан на капче
 * @return resource изображение
 */
function GenCaptcha($code){
	// Количество линий. Обратите внимание, что они накладываться будут дважды (за текстом и на текст). Поставим рандомное значение, от 3 до 5.
	$linenum = rand(3, 5);
	// Задаем фоны для капчи. Можете нарисовать свой и загрузить его в папку /img. Рекомендуемый размер - 150х70. Фонов может быть сколько угодно
	$img_arr = array(
		"1.png"
	);
	// Шрифты для капчи. Задавать можно сколько угодно, они будут выбираться случайно
	$font_arr = array();
	$font_arr[0]["fname"] = "Arial.ttf"; // Имя шрифта.
	$font_arr[0]["size"] = rand(20, 30); // Размер в pt
	//$font_arr[0]["size"] = 22; // Размер в pt
	// Генерируем "подстилку" для капчи со случайным фоном
	$n = rand(0,sizeof($font_arr)-1);
	$img_fn = $img_arr[rand(0, sizeof($img_arr)-1)];
	$im = imagecreatefrompng ('data/'.$img_fn);
	// Рисуем линии на подстилке
	for ($i=0; $i<$linenum; $i++)
	{
	$color = imagecolorallocate($im, rand(0, 150), rand(0, 100), rand(0, 150)); // Случайный цвет c изображения
	imageline($im, rand(0, 20), rand(1, 50), rand(150, 180), rand(1, 50), $color);
	}
	$color = imagecolorallocate($im, rand(0, 200), 0, rand(0, 200)); // Опять случайный цвет. Уже для текста.

	// Накладываем текст капчи
	$x = rand(0, 35);

	for($i = 0; $i < strlen($code); $i++) {
		$x+=15;
		$letter=substr($code, $i, 1);
		imagettftext ($im, $font_arr[$n]["size"], rand(2, 4), $x, rand(50, 55), $color, 'data/'.$font_arr[$n]["fname"], $letter);
	}

	// Опять линии, уже сверху текста
	for($i=0; $i<$linenum; $i++){
		$color = imagecolorallocate($im, rand(0, 255), rand(0, 200), rand(0, 255));
		imageline($im, rand(0, 20), rand(1, 50), rand(150, 180), rand(1, 50), $color);
	}
	//imagepng($im, './tmp/'.strlen($code).'/'.$code.'.png');

	// Возвращаем получившееся изображение
	return $im;
}

/** Сгенерировать произвольную строку
 *
 * @return string
 */
function GenRandStr(){
	$chars = 'abdefhknrstyz23456789'; // Задаем символы, используемые в капче. Разделитель использовать не надо.
	$numChars = strlen($chars); // Узнаем, сколько у нас задано символов
	$str='';
	for ($i=0, $x=rand(4, 5); $i < $x; $i++) {
		$str .= substr($chars, rand(1, $numChars) - 1, 1);
	}
	return $str;
}
