<?php
/** Глобальная переменная. Хранилище загруженных масок
 */
$global_masks=array();

/** Загрузить все маски
 */
function LoadAllMasks(){
	$fp=glob('masks/*', GLOB_ONLYDIR);

	foreach($fp as $dir){
		$mask_name=basename($dir);
		LoadMask($mask_name);
	}
}

/** Загрузить маску конкретного символа
 *
 * @global array $global_masks
 * @param string $mask_name загружеамый символ
 */
function LoadMask($mask_name){
	global $global_masks;
	$fp=glob('masks/'.$mask_name.'/*');
	$global_masks[$mask_name]=array();

	foreach($fp as $file){
		$arr=RecogLoadMaskFromFile($file);
		$global_masks[$mask_name][]=$arr;
	}

}

/** Распознавание маски символа. Получить распознанный символ
 *
 * @param array $mask маска символа
 * @return string
 */
function CompSumbolsGetChar($mask){
	$table=CompAllMaskSumbols($mask);

	$key=array_search(max($table), $table);

	return $key;
}

/** Сравнить маску символа с капчи со всеми масками всех символов в хранилище
 *
 * @global array $global_masks
 * @param array $mask
 * @return array массив вероятностей
 */
function CompAllMaskSumbols($mask){
	global $global_masks;

	$mask_names=array_keys($global_masks);
	$arr=array();
	foreach($mask_names as $name){

		$int=CompOneMaskSumbols($mask, $name);
		$arr[$name]=$int;
	}

	return $arr;
}

/** Сравнить маску символа, с масками одного из символов в хранилище
 *
 * @global array $global_masks
 * @param array $mask
 * @param string $mask_name проверяемый символ в хранилище
 * @return integer вероятность схожести
 */
function CompOneMaskSumbols($mask, $mask_name){
	global $global_masks;

	$my_mask=$global_masks[$mask_name];


	$arr=array();
	foreach($my_mask as $comp_mask){
		$arr[]=CompMasks($mask, $comp_mask);
	}

	$int=max($arr);

	return $int;
}

/** Сравнение двух масок
 *
 * @param array $mask1
 * @param array $mask2
 * @return integer вероятность схожести
 */
function CompMasks($mask1, $mask2){

	$int=0;
	for($ix=0, $x=count($mask1[0]); $ix<$x; $ix++){
		for($iy=0, $y=count($mask1); $iy<$y; $iy++){

			if($mask1[$iy][$ix]==1){
				if($mask1[$iy][$ix] == $mask2[$iy][$ix])$int+=1;
				else $int--;
			}else{
				if($mask1[$iy][$ix] != $mask2[$iy][$ix])$int--;
			}
		}
	}

	return $int;
}
?>
